diff --git a/mscore/scoreview.cpp b/mscore/scoreview.cpp
index 0a2d1a6..fbf5de3 100644
--- a/mscore/scoreview.cpp
+++ b/mscore/scoreview.cpp
@@ -3531,22 +3531,9 @@ void ScoreView::cmdTuplet(int n)
                   }
             }
       else {
-            QSet<ChordRest*> set;
-            for (Element* e : _score->selection().elements()) {
-                  if (e->type() == ElementType::NOTE) {
-                        Note* note = static_cast<Note*>(e);
-                        if (note->noteType() != NoteType::NORMAL) { //no tuplet on grace notes
-                              _score->endCmd();
-                              return;
-                              }
-                        e = note->chord();
-                        }
-                  if (e->isChordRest()) {
-                        ChordRest* cr = static_cast<ChordRest*>(e);
-                        if (!set.contains(cr)) {
-                              cmdTuplet(n, cr);
-                              set.insert(cr);
-                              }
+            for (ChordRest* cr : _score->getSelectedChordRests()) {
+                  if (!cr->isGrace()) {
+                        cmdTuplet(n, cr);
                         }
                   }
             }
